#include <stdio.h>
#include <string.h>

int main(int argc, char **argv)
{
  FILE *f;
  int major, minor, day, month, year;
  char tmp[1024];
  char *format;
  int item = 0;

  if (argc != 2)
  {
    fprintf(stderr, "Usage: parse_version <srcdir>\n");
    exit(2);
  }
  strcpy(tmp, argv[1]);
  strcat(tmp, "/../version.in");
  f = fopen(tmp, "r");
  if (f == NULL)
  {
    fprintf(stderr, "Cannot open %s\n", tmp);
    exit(2);
  }
  fscanf(f, "%d.%d,%d.%d.%d", &major, &minor, &day, &month, &year);
  fclose(f);
  format = "/*
 * version.h file. Automatically generated by parse_version.
 */

#ifndef __VERSION_H__
#define __VERSION_H__

#define IXNET_NAME	   \"ixnet.library\"
#define IXNET_IDSTRING	   \"ixnet %d.%d %s(%d.%d.%d)\"
#define IXNET_VERSION	   %d
#define IXNET_REVISION	   %d
#define IXNET_PRIORITY	   0

#endif
";
  strcpy(tmp, "[");

#ifdef NOTRAP
  if (item)
    strcat(tmp, ", ");
  strcat(tmp, "notrap");
  item++;
#endif

#ifdef DEBUG_VERSION
  if (item)
    strcat(tmp, ", ");
  strcat(tmp, "debug");
  item++;
#endif

  if (item)
    strcat(tmp, "] ");
  else
    tmp[0] = '\0';

  printf(format, major, minor, tmp, day, month, year, major, minor);
  return 0;
}
